--[[
MillHelp.lua
Author: Michael Joseph Murray aka Lyte of Lothar(US)
$Revision: 134 $
$Date: 2012-11-13 05:03:07 +0000 (Tue, 13 Nov 2012) $
2.0.14
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2012 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

local strformat = string.format
local strfind = string.find
local strsplit = strsplit

--localization
local L = {}
local LOCALE = GetLocale()

if LOCALE == "esES" then
	L["Milling:"] = "Moler:"
	L["Northrend Herbs"] = "Hierbas de Rasganorte"
	L["Outlands Herbs"] = "Hierbas de Terrallende"
	L["tier1"] = "Flor de paz, Hojaplata, Raíz de tierra"
	L["tier10"] = [=[Amapola de lluvia, Hoja de té verde, Hierba sedosa,
Lirio de las nieves, Flor del inocente]=]
	L["tier2"] = [=[Marregal, Brezospina, Cardopresto,
Hierba cardenal, Alga estranguladora]=]
	L["tier3"] = [=[Acérita salvaje, Musgo de tumba, Sangrerregia,
Vidarraíz]=]
	L["tier4"] = [=[Pálida, Espina de oro, Mostacho de Khadgar,
Dientes de dragón]=]
	L["tier5"] = [=[Flor de Fuego, Loto cárdeno, Lágrimas de Arthas,
Solea, Carolina, Champiñón fantasma,
 Gromsamguina]=]
	L["tier6"] = [=[Sansam dorado, Hojasueño, Salviargenta de montaña,
Musgopena, Setelo]=]
	L["tier9"] = [=[Flor de ceniza, Viñaviento, Velo de Azshara,
Flor de corazón, Jazmín Crepuscular,
Colátigo]=]

	L["Updating Item Cache"] = "Updating Item Cache" -- Requires localization

elseif LOCALE == "esMX" then
	L["Milling:"] = "Moler:"
	L["Northrend Herbs"] = "Hierbas de Rasganorte"
	L["Outlands Herbs"] = "Hierbas de Terrallende"
	L["tier1"] = "Flor de paz, Hojaplata, Raíz de tierra"
	L["tier10"] = [=[Amapola de lluvia, Hoja de té verde, Hierba sedosa,
Lirio de las nieves, Flor del inocente]=]
	L["tier2"] = [=[Marregal, Brezospina, Cardopresto,
Hierba cardenal, Alga estranguladora]=]
	L["tier3"] = [=[Acérita salvaje, Musgo de tumba, Sangrerregia,
Vidarraíz]=]
	L["tier4"] = [=[Pálida, Espina de oro, Mostacho de Khadgar,
Dientes de dragón]=]
	L["tier5"] = [=[Flor de Fuego, Loto cárdeno, Lágrimas de Arthas,
Solea, Carolina, Champiñón fantasma,
 Gromsamguina]=]
	L["tier6"] = [=[Sansam dorado, Hojasueño, Salviargenta de montaña,
Musgopena, Setelo]=]
	L["tier9"] = [=[Flor de ceniza, Viñaviento, Velo de Azshara,
Flor de corazón, Jazmín Crepuscular,
Colátigo]=]

	L["Updating Item Cache"] = "Updating Item Cache" -- Requires localization

elseif LOCALE == "deDE" then
	L["Milling:"] = "Mahlen:"
	L["Northrend Herbs"] = "Pflanzen Nordends"
	L["Outlands Herbs"] = "Pflanzen der Scherbenwelt"
	L["tier1"] = "Friedenblume, Silberblatt, Erdwurzel"
	L["tier10"] = [=[Regenmohn, Teepflanze, Seidenkraut,
Schneelilie, Narrenkappe, Entweihtes Kraut]=]
	L["tier2"] = [=[Maguskönigskraut, Wilddornrose, Flitzdistel,
Beulengras, Würgetang]=]
	L["tier3"] = "Wildstahlblume, Grabmoos, Königsblut, Lebenswurz"
	L["tier4"] = [=[Blassblatt, Golddorn, Khadgars Schnurrbart,
Drachenzahn]=]
	L["tier5"] = [=[Feuerblüte, Lila Lotus, Arthas' Tränen,
Sonnengras, Blindkraut, Geisterpilz,
Gromsblut]=]
	L["tier6"] = [=[Goldener Sansam, Traumblatt, Bergsilbersalbei,
Trauermoos, Eiskappe]=]
	L["tier9"] = [=[Aschenblüte, Sturmwinde, Azsharas Schleier,
Herzblüte, Schattenjasmin, Gertenrohr]=]

	L["Updating Item Cache"] = "Der Cache für Gegenstände wird aktualisiert"

elseif LOCALE == "ruRU" then
	L["Milling:"] = "Измельчение:"
	L["Northrend Herbs"] = "Травы Нордскола"
	L["Outlands Herbs"] = "Травы Запределья"
	L["tier1"] = "Мироцвет, Сребролист, Земляной корень"
	L["tier10"] = [=[Дождевой мак, Листья зеленого чая, Ваточник,
Снежная лилия, Дурногриб,
Оскверненная трава]=]
	L["tier2"] = [=[Магороза, Остротерн, Скорополох,
Синячник, Удавник]=]
	L["tier3"] = [=[Дикий сталецвет, Могильный мох, Королевская кровь,
Корень жизни]=]
	L["tier4"] = [=[Бледнолист, Златошип, Кадгаров ус,
Драконьи зубы]=]
	L["tier5"] = [=[Огнецвет, Лиловый лотос, Слезы Артаса,
Солнечник, Пастушья сумка, Призрачная поганка,
Кровь Грома]=]
	L["tier6"] = [=[Золотой сансам, Снолист, Горный серебряный шалфей,
Печаль-трава, Ледяной зев]=]
	L["tier9"] = [=[Пепельник, Ливневая лоза, Вуаль Азшары,
Цветущее сердце, Сумеречный жасмин,
Хлыстохвост]=]

	L["Updating Item Cache"] = "Updating Item Cache" -- Requires localization

elseif LOCALE == "frFR" then
	L["Milling:"] = "Mouture:"
	L["Northrend Herbs"] = "Herbes de Norfendre"
	L["Outlands Herbs"] = "Herbes de l'Outreterre"
	L["tier1"] = "Pacifique, Feuillargent, Terrestrine"
	L["tier10"] = [=[Pavot de pluie, Feuille de thé vert, Herbe à soie,
Lys des neiges, Berluette, Herbe désacralisée]=]
	L["tier2"] = [=[Mage royal, Eglantine, Chardonnier,
Doulourante, Etouffante]=]
	L["tier3"] = "Aciérite sauvage, Tombeline, Sang-royal, Vietérule"
	L["tier4"] = [=[Pâlerette, Dorépine, Moustache de Khadgar,
Dents de dragon]=]
	L["tier5"] = [=[Fleur de feu, Lotus pourpre, Larmes d'Arthas,
Soleillette, Aveuglette, Champignon fantôme,
Gromsang]=]
	L["tier6"] = [=[Sansam doré, Feuillerêve, Chagrinelle,
Sauge-argent des montagnes, Chapeglace]=]
	L["tier9"] = "Cendrelle, Vignétincelle, Voile d'Azshara, Pétale de cœur, Jasmin crépusculaire, Fouettine"

	L["Updating Item Cache"] = "Mise à jour du cache des objets"

elseif LOCALE == "koKR" then
	L["Milling:"] = "제분:"
	L["Northrend Herbs"] = "노스렌드 약초"
	L["Outlands Herbs"] = "아웃랜드 약초"
	L["tier1"] = "평온초 꽃잎, 은엽수잎, 뱀뿌리"
	L["tier10"] = [=[빗방울 백일홍, 녹차 잎, 비단풀,
눈 백합, 멍텅구리 모자 버섯, 더럽혀진 약초]=] -- Needs review
	L["tier2"] = [=[마법초 꽃잎, 찔레가시, 토끼엉겅퀴풀,
생채기풀, 갈래물풀]=]
	L["tier3"] = "야생 철쭉, 무덤이끼, 왕꽃잎풀, 생명의 뿌리"
	L["tier4"] = [=[미명초잎, 황금가시, 카드가의 수염,
겨울서리풀]=]
	L["tier5"] = [=[화염초 꽃잎, 보라 연꽃, 아서스의 눈물,
태양풀, 실명초, 유령버섯, 그롬의 피]=]
	L["tier6"] = [=[황금 산삼, 꿈풀, 은초롱이,
슬픔이끼, 얼음송이]=]
	L["tier9"] = [=[재투성이꽃, 폭풍덩굴, 아즈샤라의 신비,
심장꽃, 황혼의 말리꽃, 채찍꼬리]=]

	L["Updating Item Cache"] = "아이템 캐시 업데이트" -- Needs review

elseif LOCALE == "zhCN" then
	L["Milling:"] = "研磨:"
	L["Northrend Herbs"] = "诺森德草药"
	L["Outlands Herbs"] = "外域草药"
	L["tier1"] = "宁神花,银叶草,地根草"
	L["tier10"] = [=[Rain Poppy, Green Tea Leaf, Silkweed,
Snow Lily, Fool's Cap, Desecrated Herb]=] -- Requires localization
	L["tier2"] = [=[魔皇草,石南草,雨燕草,
跌打草,荆棘藻]=]
	L["tier3"] = "野钢花,墓地苔,皇血草,活根草"
	L["tier4"] = [=[枯叶草,金棘草,卡德加的胡须,
冬刺草]=]
	L["tier5"] = [=[火焰花,紫莲花,阿尔萨斯之泪,
太阳草,盲目草,幽灵菇,
格罗姆之血]=]
	L["tier6"] = [=[黄金参,梦叶草,山鼠草,
瘟疫花,冰盖草]=]
	L["tier9"] = [=[Cinderbloom, Stormvine, Azshara's Veil,
Heartblossom, Twilight Jasmine, Whiptail]=] -- Needs review

	L["Updating Item Cache"] = "Updating Item Cache" -- Requires localization

elseif LOCALE == "zhTW" then
	L["Milling:"] = "研磨:"
	L["Northrend Herbs"] = "北裂境草藥"
	L["Outlands Herbs"] = "外域草藥"
	L["tier1"] = "寧神花, 銀葉草, 地根草"
	L["tier10"] = [=[Rain Poppy, Green Tea Leaf, Silkweed,
Snow Lily, Fool's Cap, Desecrated Herb]=] -- Requires localization
	L["tier2"] = [=[魔皇草, 石南草, 雨燕草,
跌打草, 荊棘藻]=]
	L["tier3"] = "野鋼花, 墓地苔, 皇血草, 活根草"
	L["tier4"] = [=[枯葉草, 金棘草, 卡德加的鬍鬚,
冬刺草]=]
	L["tier5"] = [=[火焰花, 紫蓮花, 阿薩斯之淚,
太陽草, 盲目草, 鬼魂菇,
格羅姆之血]=]
	L["tier6"] = [=[黃金蔘, 夢葉草, 山鼠草,
瘟疫花, 冰蓋草]=]
	L["tier9"] = [=[燼花, 風暴藤, 艾薩拉的帷紗,
心綻花, 暮光茉莉, 鞭尾蜥草]=]

	L["Updating Item Cache"] = "更新物品快取"

elseif LOCALE == "ptBR" then
	L["Milling:"] = "Triturar Ervas:"
	L["Northrend Herbs"] = "Plantas Nortúndria" -- Needs review
	L["Outlands Herbs"] = "Outlands Herbs" -- Requires localization
	L["tier1"] = "Botão-da-paz, Folha-prata, Raiz-telúrica"
	L["tier10"] = [=[Papoula-da-chuva, Folha de Chá Verde, Flor-de-seda,
Lírio-das-neves, Chapéu dos Tolos]=]
	L["tier2"] = [=[Magi-real, Cravespinho, Cardo-veloz,
Ervamossa, Estrangulalga]=]
	L["tier3"] = [=[Ácera-agreste, Musgo de Tumba, Sangue-real,
Raiz-da-vida]=]
	L["tier4"] = [=[Some-folha, Espinheira-dourada,
Bigode-de-hadggar, Dentes de Dragão]=]
	L["tier5"] = [=[Ignídea, Lótus Roxo, Lágrimas-de-arthas,
Ervassol, Ervacega, Cogumelo-fantasma,
Sangue-de-grom]=]
	L["tier6"] = [=[Sonsona-dourada, Folha-de-sonho,
Sálvia-prata-da-montanha, Limágoa,
Chapéu-de-gelo]=]
	L["tier9"] = [=[Cinzanilha, Tempesvina, Véu-de-azshara,
Coronália, Jasmim-do-crepúsculo,
Azorrague]=]

	L["Updating Item Cache"] = "Updating Item Cache" -- Requires localization

elseif LOCALE == "itIT" then
	L["Milling:"] = "Milling:" -- Requires localization
	L["Northrend Herbs"] = "Northrend Herbs" -- Requires localization
	L["Outlands Herbs"] = "Outlands Herbs" -- Requires localization
	L["tier1"] = "Peacebloom, Silverleaf, Earthroot" -- Requires localization
	L["tier10"] = [=[Rain Poppy, Green Tea Leaf, Silkweed,
Snow Lily, Fool's Cap, Desecrated Herb]=] -- Requires localization
	L["tier2"] = [=[Mageroyal, Briarthorn, Swiftthistle,
Bruiseweed, Stranglekelp]=] -- Requires localization
	L["tier3"] = "Wild Steelbloom, Grave Moss, Kingsblood, Liferoot" -- Requires localization
	L["tier4"] = [=[Fadeleaf, Goldthorn, Khadgar's Whisker,
Dragon's Teeth]=] -- Requires localization
	L["tier5"] = [=[Firebloom, Purple Lotus, Arthas' Tears,
Sungrass, Blindweed, Ghost Mushroom,
Gromsblood]=] -- Requires localization
	L["tier6"] = [=[Golden Sansam, Dreamfoil, Mountain Silversage,
Sorrowmoss, Icecap]=] -- Requires localization
	L["tier9"] = [=[Cinderbloom, Stormvine, Azshara's Veil,
Heartblossom, Twilight Jasmine, Whiptail]=] -- Requires localization

	L["Updating Item Cache"] = "Updating Item Cache" -- Requires localization

else
	L["Milling:"] = "Milling:"
	L["Northrend Herbs"] = "Northrend Herbs"
	L["Outlands Herbs"] = "Outlands Herbs"
	L["tier1"] = "Peacebloom, Silverleaf, Earthroot"
	L["tier10"] = [=[Rain Poppy, Green Tea Leaf, Silkweed,
Snow Lily, Fool's Cap, Desecrated Herb]=]
	L["tier2"] = [=[Mageroyal, Briarthorn, Swiftthistle,
Bruiseweed, Stranglekelp]=]
	L["tier3"] = "Wild Steelbloom, Grave Moss, Kingsblood, Liferoot"
	L["tier4"] = [=[Fadeleaf, Goldthorn, Khadgar's Whisker,
Dragon's Teeth]=]
	L["tier5"] = [=[Firebloom, Purple Lotus, Arthas' Tears,
Sungrass, Blindweed, Ghost Mushroom,
Gromsblood]=]
	L["tier6"] = [=[Golden Sansam, Dreamfoil, Mountain Silversage,
Sorrowmoss, Icecap]=]
	L["tier9"] = [=[Cinderbloom, Stormvine, Azshara's Veil,
Heartblossom, Twilight Jasmine, Whiptail]=]

	L["Updating Item Cache"] = "Updating Item Cache"

end

--a table of herb itemIDs to common pigment itemIDs
local commonPigments = {
	["2449"] = 39151, --alabaster
	["2447"] = 39151,
	["765"] = 39151,
	["785"] = 39334, --dusky
	["2450"] = 39334,
	["3820"] = 39334,
	["2452"] = 39334,
	["2453"] = 39334,
	["3357"] = 39338, --golden
	["3356"] = 39338,
	["3355"] = 39338,
	["3369"] = 39338,
	["3358"] = 39339, --emerald
	["3821"] = 39339,
	["3819"] = 39339,
	["3818"] = 39339,
	["4625"] = 39340, --violet
	["8831"] = 39340,
	["8836"] = 39340,
	["8838"] = 39340,
	["8839"] = 39340,
	["8845"] = 39340,
	["8846"] = 39340,
	["13464"] = 39341, --silvery
	["13463"] = 39341,
	["13465"] = 39341,
	["13466"] = 39341,
	["13467"] = 39341,
	["22787"] = 39342, --nether
	["22790"] = 39342,
	["22789"] = 39342,
	["22792"] = 39342,
	["22791"] = 39342,
	["22785"] = 39342,
	["22793"] = 39342,
	["22786"] = 39342,
	["36906"] = 39343, --azure
	["36905"] = 39343,
	["36901"] = 39343,
	["37921"] = 39343,
	["36904"] = 39343,
	["36903"] = 39343,
	["36907"] = 39343,
	["39970"] = 39343,
	["52983"] = 61979, --ashen
	["52986"] = 61979,
	["52987"] = 61979,
	["52985"] = 61979,
	["52984"] = 61979,
	["52988"] = 61979,
	["72237"] = 79251, --shadow
	["72234"] = 79251,
	["72235"] = 79251,
	["79010"] = 79251,
	["79011"] = 79251,
	["89639"] = 79251,
}

--a table of herb itemIDs to rare pigment itemIDs
local rarePigments = {
	["3356"] = 43104, --burnt
	["3357"] = 43104,
	["3369"] = 43104,
	["3355"] = 43104,
	["785"] = 43103, --verdant
	["2450"] = 43103,
	["2452"] = 43103,
	["2453"] = 43103,
	["3820"] = 43103,
	["13466"] = 43107, --sapphire
	["13465"] = 43107,
	["13467"] = 43107,
	["13464"] = 43107,
	["13463"] = 43107,
	["4625"] = 43106, --ruby
	["8831"] = 43106,
	["8836"] = 43106,
	["8838"] = 43106,
	["8839"] = 43106,
	["8845"] = 43106,
	["8846"] = 43106,
	["22791"] = 43108, --ebon
	["22793"] = 43108,
	["22792"] = 43108,
	["22790"] = 43108,
	["22789"] = 43108,
	["22786"] = 43108,
	["22785"] = 43108,
	["22787"] = 43108,
	["36903"] = 43109, --icy
	["36905"] = 43109,
	["36906"] = 43109,
	["36901"] = 43109,
	["37921"] = 43109,
	["36904"] = 43109,
	["36907"] = 43109,
	["39970"] = 43109,
	["3358"] = 43105, --indigo
	["3821"] = 43105,
	["3819"] = 43105,
	["3818"] = 43105,
	["52983"] = 61980, --burning embers
	["52986"] = 61980,
	["52987"] = 61980,
	["52985"] = 61980,
	["52984"] = 61980,
	["52988"] = 61980,
	["72237"] = 79253, --misty
	["72234"] = 79253,
	["72235"] = 79253,
	["79010"] = 79253,
	["79011"] = 79253,
	["89639"] = 79253,
}

--a table of ink itemIDs to herb sets
local inkTable = {
	["37101"] = L["tier1"], --ivory ink (alabaster pigment)
	["39469"] = L["tier1"], --moonglow ink (alabaster pigment)
	["39774"] = L["tier2"], --midnight ink (dusky pigment)
	["43115"] = L["tier2"], --hunter's ink (verdant pigment)
	["43116"] = L["tier3"], --lion's ink (golden pigment)
	["43117"] = L["tier3"], --dawnstar ink (burnt pigment)
	["43118"] = L["tier4"], --jadefire ink (emerald pigment)
	["43119"] = L["tier4"], --royal ink (indigo pigment)
	["43120"] = L["tier5"], --celestial ink (violet pigment)
	["43121"] = L["tier5"], --fiery ink (Ruby Pigment)
	["43122"] = L["tier6"], --shimmering ink (silvery pigment)
	["43123"] = L["tier6"], --ink of the sky (Saphire Pigment)
	["43124"] = L["Outlands Herbs"], --ethereal ink (nether pigment)
	["43125"] = L["Outlands Herbs"], --darkflame ink (ebon pigment)
	["43126"] = L["Northrend Herbs"], --ink of the sea (azure pigment)
	["43127"] = L["Northrend Herbs"], -- snowfall ink (icy pigment)
	["61978"] = L["tier9"], -- blackfallow ink (ashen pigment)
	["61981"] = L["tier9"], --inferno ink (burning embers)
	["79254"] = L["tier10"], --ink of dreams (shadow pigment)
	["79255"] = L["tier10"], --starlight ink (misty pigment)
}

local inksToPigments = {
	["37101"] = 39151, --ivory ink (alabaster pigment)
	["39469"] = 39151, --moonglow ink (alabaster pigment)
	["39774"] = 39334, --midnight ink (dusky pigment)
	["43115"] = 43103, --hunter's ink (verdant pigment)
	["43116"] = 39338, --lion's ink (golden pigment)
	["43117"] = 43104, --dawnstar ink (burnt pigment)
	["43118"] = 39339, --jadefire ink (emerald pigment)
	["43119"] = 43105, --royal ink (indigo pigment)
	["43120"] = 39340, --celestial ink (violet pigment)
	["43121"] = 43106, --fiery ink (Ruby Pigment)
	["43122"] = 39341, --shimmering ink (silvery pigment)
	["43123"] = 43107, --ink of the sky (Saphire Pigment)
	["43124"] = 39342, --ethereal ink (nether pigment)
	["43125"] = 43108, --darkflame ink (ebon pigment)
	["43126"] = 39343, --ink of the sea (azure pigment)
	["43127"] = 43109, -- snowfall ink (icy pigment)
	["61978"] = 61979, -- blackfallow ink (ashen pigment)
	["61981"] = 61980, -- inferno ink (burning embers)
	["79254"] = 79251, --ink of dreams (shadow pigment)
	["79255"] = 79253, --starlight ink (misty pigment)
}

local pigmentsToInks = {
	["39151"] = 37101, --ivory ink (alabaster pigment)
	["39151"] = 39469, --moonglow ink (alabaster pigment)
	["39334"] = 39774, --midnight ink (dusky pigment)
	["43103"] = 43115, --hunter's ink (verdant pigment)
	["39338"] = 43116, --lion's ink (golden pigment)
	["43104"] = 43117, --dawnstar ink (burnt pigment)
	["39339"] = 43118, --jadefire ink (emerald pigment)
	["43105"] = 43119, --royal ink (indigo pigment)
	["39340"] = 43120, --celestial ink (violet pigment)
	["43106"] = 43121, --fiery ink (Ruby Pigment)
	["39341"] = 43122, --shimmering ink (silvery pigment)
	["43107"] = 43123, --ink of the sky (Saphire Pigment)
	["39342"] = 43124, --ethereal ink (nether pigment)
	["43108"] = 43125, --darkflame ink (ebon pigment)
	["39343"] = 43126, --ink of the sea (azure pigment)
	["43109"] = 43127, -- snowfall ink (icy pigment)
	["61979"] = 61978, --blackfallow ink (ashen pigment)
	["61980"] = 61981, --inferno ink (burning embers)
	["79251"] = 79254, --ink of dreams (shadow pigment)
	["79253"] = 79255, --starlight ink (misty pigment)
}

local getInscriptionInfo = setmetatable({}, {
	__index = function(t, k)
		local herbset = inkTable[k]
		local cPigment = commonPigments[k]
		local rPigment = rarePigments[k]
		local n1, n2, n3, n4
		
		--if herbset is not nil then the itemID belongs to an ink
		--and that means we need to add the needed pigment
		if herbset then
			local pigment = inksToPigments[k]
			n1 = GetItemInfo(pigment)
			--make sure the item returned a name, errors scare users
			if n1 == nil then
				t[k] = L["Updating Item Cache"]
				return t[k]
			end
			t[k] = strformat("|cffffffff%s\n%s|r", n1, herbset)
		end
		--if rPigment is not nil then the itemID belongs to an herb with a rare pigment result
		--this automatically means that cPigment is not nil as well
		--we add a line to the tooltip for both pigments and a line for the two inks
		if rPigment then
			local cInk = pigmentsToInks[tostring(cPigment)]
			local rInk = pigmentsToInks[tostring(rPigment)]
			--make sure the item returned a name, errors scare users
			n1, n2, n3, n4 = GetItemInfo(cPigment), GetItemInfo(cInk), GetItemInfo(rPigment), GetItemInfo(rInk)
			if n1 == nil or n2 == nil or n3 == nil or n4 == nil then
				t[k] = L["Updating Item Cache"]
				return t[k]
			end
			t[k] = strformat("|cffffffff%s (%s)|r\n|cff1eff00%s (%s)|r", n1, n2, n3, n4)
		--if rPigment is nil but cPigment is not nil
		--then the itemID is for a herb that makes the first two inks
		--so we just add the pigment to the tool tip and those two inks
		elseif cPigment then
			--make sure the item returned a name, errors scare users
			n1, n2, n3 = GetItemInfo(cPigment), GetItemInfo(37101), GetItemInfo(39469)
			if n1 == nil or n2 == nil or n3 == nil then
				t[k] = L["Updating Item Cache"]
				return t[k]
			end
			t[k] = strformat("|cffffffff%s\n(%s, %s)|r", n1, n2, n3)
		end
		
		return t[k]
	end
})

local _, ns = ...
function ns:ClearCachedTooltips()
	for k in pairs(getInscriptionInfo) do
		getInscriptionInfo[k] = nil
	end
end

local function AddMillingInfo(frame, itemLink)
	local _, _, itemString = strfind(itemLink, "^|c%x+|H(.+)|h%[.+%]")
	if itemString then
		local _, itemID = strsplit(":", itemString)
		if itemID then
			if inkTable[itemID] or rarePigments[itemID] or commonPigments[itemID] then
				if MILLHELP_HEADER then
					frame:AddLine(strformat("|cffffffff%s|r", L["Milling:"]))
				end
				frame:AddLine(getInscriptionInfo[itemID])
			end
		end
	end
	
	frame:Show()
end

local function HookIt(tt)
	tt:HookScript("OnTooltipSetItem", function(self, ...)
		local itemLink = select(2, self:GetItem())
		if itemLink and GetItemInfo(itemLink) then
			AddMillingInfo(self, itemLink)
		end
	end)
end

HookIt(GameTooltip)
HookIt(ItemRefTooltip)
